﻿local addonName, ns = ...
local spirit = { [69680] = 'storm', [69791] = 'fire', [69792] = 'earth' }

local Shifu = CreateFrame('frame', 'Shifu', UIParent)
Shifu.spirits = {}

Shifu:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
Shifu:RegisterEvent('PLAYER_TOTEM_UPDATE')
Shifu:RegisterEvent('PLAYER_TARGET_CHANGED')
Shifu:SetPoint('CENTER', -256, 0)
Shifu:SetSize(256, 256)

Shifu.funnyPic = Shifu:CreateTexture(nil, 'OVERLAY')
Shifu.funnyPic:SetAllPoints()
Shifu.funnyPic:SetTexture('Interface\\AddOns\\'..addonName..'\\Shifu')
Shifu.funnyPic:SetDrawLayer('OVERLAY', 0)

Shifu.spellType = Shifu:CreateTexture(nil, 'OVERLAY')
Shifu.spellType:SetSize(22, 22)
Shifu.spellType:SetPoint('TOPLEFT', 27, -56)
Shifu.spellType:SetTexCoord(.1, .9, .1, .9)
Shifu.spellType:SetDrawLayer('OVERLAY', 1)

Shifu.spellTypeBorder = Shifu:CreateTexture(nil, 'OVERLAY')
Shifu.spellTypeBorder:SetTexture('Interface\\Minimap\\MiniMap-TrackingBorder')
Shifu.spellTypeBorder:SetSize(64, 64)
Shifu.spellTypeBorder:SetPoint('TOPLEFT', 18, -48)
Shifu.spellTypeBorder:SetDrawLayer('OVERLAY', 2)

Shifu.funnyPic:Hide()
Shifu.spellType:Hide()
Shifu.spellTypeBorder:Hide()

local checkTarget = function(self)
     local target = UnitGUID("target")
     self.funnyPic:Hide()
     self.spellType:Hide()
     self.spellTypeBorder:Hide()
     if target then
          for name, t in pairs(self.spirits) do
               if t.target == target then
                    self.funnyPic:Show()
                    self.spellType:SetTexture(t.icon)
                    self.spellType:Show()
                    self.spellTypeBorder:Show()
                    return
               end
          end
     end     
end

Shifu:SetScript('OnEvent', function(self, sevent, ...)
     local playerGUID = UnitGUID("player")
     if sevent == 'COMBAT_LOG_EVENT_UNFILTERED' then
          if select(4, ...) == playerGUID then
               local event = select(2, ...)
               if event == "SPELL_SUMMON" then
                    local dest, dstName = select(8, ...)
                    if bit.band(tonumber(dest:sub(5,5), 16), 0x7) == 0x3 then
                         local guid = tonumber(dest:sub(6,10), 16)
                         if spirit[guid] then
                              self.spirits[dstName] = {}
                              self.last = self.spirits[dstName]
                         end
                    end
               elseif event == 'SPELL_CAST_SUCCESS' then
                    local spellid = select(12, ...)
                    if spellid == 137639 then
                         local dest, dstName = select(8, ...)
                         if self.last then
                              self.last.target = dest
                              self.last = nil
                         end
                    end
               end
               checkTarget(self)
          end
     elseif sevent == 'PLAYER_TARGET_CHANGED' then
          checkTarget(self)
     elseif sevent == 'PLAYER_TOTEM_UPDATE' then
          local foundSpirits = {}
          for i = 1, MAX_TOTEMS do
               local haveTotem, name, _, _, icon = GetTotemInfo(i)
               if haveTotem and name and self.spirits[name] then
                    self.spirits[name].icon = icon
                    foundSpirits[name] = true
               end
          end
          for name, t in pairs(self.spirits) do
               if not foundSpirits[name] then
                    self.spirits[name] = nil
               end
          end
          checkTarget(self)
     end
end)